import { OramaPluginSync } from '@orama/orama';
import { OramaProxy, ChatModel, EmbeddingModel } from '@oramacloud/client';

type SecureProxyExtra = {
    proxy: OramaProxy;
    pluginParams: SecureProxyPluginOptions;
};
type LLMModel = ChatModel;
type SecureProxyPluginOptions = {
    apiKey: string;
    embeddings: {
        defaultProperty: string;
        model: EmbeddingModel;
        onInsert?: {
            generate: boolean;
            properties: string[];
            verbose?: boolean;
        };
    };
    chat?: {
        model: LLMModel;
    };
};
declare function pluginSecureProxy(pluginParams: SecureProxyPluginOptions): OramaPluginSync<SecureProxyExtra>;

export { type LLMModel, type SecureProxyExtra, type SecureProxyPluginOptions, pluginSecureProxy };
